package cn.skcks.study.springcloud.kafka.producer.controller;

import cn.skcks.study.springcloud.kafka.common.model.dto.Message;
import cn.skcks.study.springcloud.utils.JsonUtils;
import com.fasterxml.jackson.core.JsonProcessingException;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

@RestController
@AllArgsConstructor
public class SimpleController {
    private KafkaTemplate<Object, String> kafkaTemplate;
    final static String TOPIC_NAME = "test";

    @GetMapping("/api/v2/{num}")
    public void sendMessage1(@PathVariable("num") String num) throws JsonProcessingException {

        Message message = new Message();
        message.setData("这是一个消息,num="+num);

        kafkaTemplate.send(TOPIC_NAME,num, JsonUtils.toJson(message)).addCallback(success->{
            System.out.println("发送成功");

        },failure->{
            System.out.println("发送消息失败："+failure.getMessage());
        });
    }
}
